/*
 * Ejbtest.java
 *
 * Created on November 28, 2006, 9:25 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ejb.test;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * Entity class Ejbtest
 *
 * @author mareks
 */
@Entity
@Table(name = "ejbtest")
@NamedQueries( {
    @NamedQuery(name = "Ejbtest.findById", query = "SELECT e FROM Ejbtest e WHERE e.id = :id"),
    @NamedQuery(name = "Ejbtest.findByName", query = "SELECT e FROM Ejbtest e WHERE e.name = :name")
})
public class Ejbtest implements Serializable {
    
    @Id
    @Column(name = "id", nullable = false)
    private Integer id;
    
    @Column(name = "name")
    private String name;
    
    @OneToMany(cascade=CascadeType.ALL, mappedBy = "idd")
    private Collection<Ejbtest> ejbtestCollection;
    
    @JoinColumn(name = "idd", referencedColumnName = "id")
    @ManyToOne
    private Ejbtest idd;
    
    /** Creates a new instance of Ejbtest */
    public Ejbtest() {
    }
    
    /**
     * Creates a new instance of Ejbtest with the specified values.
     * @param id the id of the Ejbtest
     */
    public Ejbtest(Integer id) {
        this.id = id;
    }
    
    /**
     * Gets the id of this Ejbtest.
     * @return the id
     */
    public Integer getId() {
        return this.id;
    }
    
    /**
     * Sets the id of this Ejbtest to the specified value.
     * @param id the new id
     */
    public void setId(Integer id) {
        this.id = id;
    }
    
    /**
     * Gets the name of this Ejbtest.
     * @return the name
     */
    public String getName() {
        return this.name;
    }
    
    /**
     * Sets the name of this Ejbtest to the specified value.
     * @param name the new name
     */
    public void setName(String name) {
        this.name = name;
    }
    
    /**
     * Gets the ejbtestCollection of this Ejbtest.
     * @return the ejbtestCollection
     */
    public Collection<Ejbtest> getEjbtestCollection() {
        return this.ejbtestCollection;
    }
    
    /**
     * Sets the ejbtestCollection of this Ejbtest to the specified value.
     * @param ejbtestCollection the new ejbtestCollection
     */
    public void setEjbtestCollection(Collection<Ejbtest> ejbtestCollection) {
        this.ejbtestCollection = ejbtestCollection;
    }
    
    /**
     * Gets the idd of this Ejbtest.
     * @return the idd
     */
    public Ejbtest getIdd() {
        return this.idd;
    }
    
    /**
     * Sets the idd of this Ejbtest to the specified value.
     * @param idd the new idd
     */
    public void setIdd(Ejbtest idd) {
        this.idd = idd;
    }
    
    /**
     * Returns a hash code value for the object.  This implementation computes
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }
    
    /**
     * Determines whether another object is equal to this Ejbtest.  The result is
     * <code>true</code> if and only if the argument is not null and is a Ejbtest object that
     * has the same id field values as this object.
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Ejbtest)) {
            return false;
        }
        Ejbtest other = (Ejbtest)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }
    
    /**
     * Returns a string representation of the object.  This implementation constructs
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "ejb.test.Ejbtest[id=" + id + "]";
    }
    
}
